program bulkrpl;
{$I-} {$R-}
{Written by Hunter Beanland. http://www.geocities.com/SiliconValley/Lab/1672/
 Please do not delete these lines!}
uses dos;

var
 len,i,n,q,numfiles,filecount:integer;
 recurse:boolean;
 ch:char;
 infile,outfile:text;
 filein,fileout,line,temp:string;
 filespec,oldstring,newstring:string;
 fileinfo:searchrec;

procedure upstr(var line:string);
var ii:integer;
begin
 for ii:=1 to length(line) do
  line[ii]:=upcase(line[ii]);
end;

procedure stop(c:byte);
begin
 write(#13#10'Error ');
 if c=1 then writeln('writing file ',fileout)
 else writeln('reading file ',filein);
 halt;
end;

procedure openfi(filen:string);
begin
  n:=ioresult;
  assign(infile,filen);
  setfattr(outfile,0);
  n:=doserror;
  filein:=filen;
  reset(infile);
  if ioresult<>0 then stop(5);
end;

procedure openfo(filen:string);
begin
  n:=ioresult;
  assign(outfile,filen);
  setfattr(outfile,0);
  n:=doserror;
  fileout:=filen;
  rewrite(outfile);
  if ioresult<>0 then stop(1);
end;

procedure cmdline;    { get the real command line -- not used }
var h:word;
begin
  h:=word(prefixseg);
  i:=$82;
  line:='';
  repeat
   q:=mem[h:i];
   line:=line+char(q);
   inc(i);
  until (q=$d);
writeln(line);
end;

procedure replaceit(path,filename:string);
{line = string intact. temp = upcase string for detect only}
{not very effiecent, but easy to write :) }
begin
  numfiles:=numfiles+1;
  write(#13,numfiles);
  assign(infile,path+filename);
  rename(infile,path+'BULKRPL.TMP');
  openfi(path+'BULKRPL.TMP');
  openfo(path+filename);
  findfirst(filein,anyfile,fileinfo);
  len:=length(oldstring);
  line:='';  {construct a reverse (right to left) FIFO buffer}
  temp:='';
  for filecount:=1 to fileinfo.size do begin
    read(infile,ch);
    if ioresult<>0 then stop(2);
    while (filecount>len) and (length(line)>=len) do begin {don't write out }
      write(outfile,line[1]);                             {if short or write}
      if ioresult<>0 then stop(1);                        {till correct len}
      delete(line,1,1);
      delete(temp,1,1);
    end;
    line:=line+ch;
    temp:=temp+upcase(ch);

    n:=pos(oldstring,temp);   {detect & replace - may shorten buffer}
    if n>0 then begin
      delete(line,n,len);
      insert(newstring,line,n);
      delete(temp,n,len);
      insert(newstring,temp,n);
    end;

  end;
  for i:=1 to length(line) do begin       {flush buffer}
    write(outfile,line[i]);
    if ioresult<>0 then stop(1);
  end;
  close(infile);
  erase(infile);
  close(outfile);
end;

procedure searchdirectory(path,spec:string);
{re-entrant & recursive file finder}
var fileinfo2:searchrec;
begin
  findfirst(path+spec,anyfile,fileinfo2);
  while doserror=0  do  begin
    if (fileinfo2.attr and directory)<>directory then replaceit(path,fileinfo2.name);
    findnext(fileinfo2);
  end;

  findfirst (path+'*.*',directory,fileinfo2);      {recurse}
  while doserror=0 do begin
    if (((fileinfo2.attr and directory)=directory) and (recurse) and
      (fileinfo2.name <> '.') and (fileinfo2.name <> '..')) then
      searchdirectory(path+fileinfo2.name+'\',spec);
    findnext (fileinfo2)
  end
end;

begin
  writeln('=== Bulk String Replacer === v1.1  Hunter Beanland 1998');
  if (paramcount<3) or (paramcount>4) then begin
    writeln('Syntax: BulkRPL [/R] FileSpec OldString NewString');
    writeln('ie: BulkRPL /r ??????PD.HTM width=30 width=15');
    writeln('/r = recurse directories');
    writeln('Don''t use spaces in strings, use alt-255 (on numpad) instead');
    writeln('If no new string is wanted, use alt-254');
    halt;
  end;
  recurse:=false;
  if paramcount=4 then begin
    line:=paramstr(1);
    upstr(line);
    if line='/R' then recurse:=true;
    filespec:=paramstr(2);
    oldstring:=paramstr(3);
    newstring:=paramstr(4);
  end else begin
    filespec:=paramstr(1);
    oldstring:=paramstr(2);
    newstring:=paramstr(3);
  end;
  for i:=1 to length(newstring) do
    if ord(newstring[i])=255 then newstring[i]:=' ';
  for i:=1 to length(oldstring) do
    if ord(oldstring[i])=255 then oldstring[i]:=' ';
  if ord(newstring[1])=254 then newstring:='';
  writeln('File Spec: ',filespec);
  getdir(0,line);
  numfiles:=0;
  if recurse then write('Recursing directories from')
  else write('Only processing directory');
  writeln(' ',line);
  writeln('Replacing "',oldstring,'" with "',newstring,'"'#10);
  write('Files processed:'#13#10,'0');
  upstr(oldstring);
  searchdirectory(line+'\',filespec);
  writeln(#13#10'Done');
end.